//+------------------------------------------------------------------+
//|                                                        test1.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict


//
extern string com="__ZigZag_Pointer";
extern int ExtDepth=30;
extern int ExtDeviation=5;
extern int ExtBackstep=3;
//
extern string com1="_";
extern double  ATR_prcnt          = 30;
extern int     ATR_Day_period     = 21;
extern double  Lots               = 0.01;
extern int     TrailingStop       = 30;
extern int     TrailingStep       = 10;
extern int     Slippage           = 5;
extern int     Magic              = 1981;

//
double zzH = 0.0;               //  zigzag 
double zzL = 0.0;               //  zigzag 
int Bay_Sell = -1;              //  zigzag
int Bay_Sell_one=-1; // 
                     //

datetime timeprev;
double LMA;
double atr;
double   SL;
int tick; //  
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int Init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void Deinit()
  {

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
int start()
  {
// 
   if(OpenOrderSymbol(Symbol())==0) //       (   )
      PickZZ();
      else
      Trailing(); 
      

   if(OpenOrderSymbol(Symbol())==0) //      
     {
      atr=NormalizeDouble((iATR(NULL,PERIOD_D1,ATR_Day_period,1)*0.01*ATR_prcnt),Digits);

      if(Bay_Sell==1 && zzL==Bid) // ** Buy **  //   
        {
         tick=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,NormalizeDouble((Ask-atr),Digits),0,"My order",Magic,0,clrGreen); //      
        }
      if(Bay_Sell==0 && zzH==Bid) // ** Sell ** //   
        {
         tick=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,NormalizeDouble((Bid+atr),Digits),0,"My order",Magic,0,clrRed); //      
        }
     }
   return(0);
  }
//+------------------------------------------------------------------+
void Trailing()
  {
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY)
              {
               if(Bid-OrderOpenPrice()>TrailingStop*Point)
                 {
                  if(OrderStopLoss()<Bid -(TrailingStop+TrailingStep)*Point)
                    {
                     SL=NormalizeDouble(Bid-TrailingStop *Point,Digits);
                     if(OrderStopLoss()!=SL)
                        if(OrderModify(OrderTicket(),OrderOpenPrice(),SL,0,0))
                          {
                           //      
                          }
                    }
                 }
              }
            if(OrderType()==OP_SELL)
              {
               if(OrderOpenPrice()-Ask>TrailingStop*Point)
                 {
                  if(OrderStopLoss()>Ask+(TrailingStop+TrailingStep)*Point)
                    {
                     SL=NormalizeDouble(Ask+TrailingStop *Point,Digits);
                     if(OrderStopLoss()!=SL)
                        if(OrderModify(OrderTicket(),OrderOpenPrice(),SL,0,0))
                          {
                           //      
                          }
                    }
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+


int OpenOrderSymbol(string symvol) //   --     
  {
   int kol=0; //  

   for(int pos=0; pos<OrdersTotal(); pos++)
     {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol())
           {
            kol++;

           }
        }
     }

   return(kol);
  }
  
//-----------------------------------------//
//        zigzag  //
//       zigzag  //
//    ************-Walle-***************   //
//    ( )  zigzag    //
// double zzH = 0.0;   zigzag          //
// double zzL = 0.0;    zigzag          //
// Bay_Sell = -1;      zigzag   //

void PickZZ()
  {
   double zz=0.0; // 
   int I_zzH = 0; 
   int I_zzL = 0;
   int i=0;
   int buf=0;  //  
   if(Bars>300) //      ...

     {
      while(buf<2)
        {
         for(i=0; i<Bars; i++)
           {
            zz=iCustom(NULL,0,"ZigZag_Pointer",ExtDepth,ExtDeviation,ExtBackstep,buf,i);
            // 0 -  
            // 1 -  

            if(zz!=0 && buf==1)
              {
               zzH=zz;
               I_zzH=i;
               break;
              }
            if(zz!=0 && buf==0)
              {
               zzL=zz;
               I_zzL=i;
               break;
              }
           }
         buf++;
        }

      if(I_zzH>I_zzL)
        {
         Bay_Sell=1;
         if(Bay_Sell_one!=Bay_Sell)
           {
            Print("zigzag  -  ** Buy **");

            Bay_Sell_one=Bay_Sell;
           }
        }

      if(I_zzH<I_zzL)
        {
         Bay_Sell=0;
         if(Bay_Sell_one!=Bay_Sell)
           {
            Print("gigzag  -  ** Sell **");
            Bay_Sell_one=Bay_Sell;
           }
        }
     }
  }
//---------------End Funk. PickZZ------------------------//
